% Supply Chain Coordination Using Contracts
% Inputs
prc=input('Enter the production cost: ');
pc=input('Enter the purchase cost: ');
sp=input('Enter the selling price: ');
sv=input('Enter the salvage value: ');
sc=input('Enter the shortage cost: ');
m_d=input('Enter the mean value of the demand: ');
sd_d=input('Enter the standard deviation of the demand: ');
r=input('Enter the number of simulation runs: ');
iv=input('Enter the increment value by which the quantity will vary: ');
q_max = input('Enter the Quantity Q which was recommended by Price Only contract: ');
f=input('f is the fraction of the total revenue of the retailer given to the wholesaler: ');

% Sample Values
% prc=0.2;
% pc=0.35;
% sp=0.45;
% sv=0.05;
% sc=0.3;
% m_d=30;
% sd_d=6.2;
% r=1000;
% iv=1;
% q_max=31.4;
% f=0.3;

tp=0;
for i=1:r 
    z=m_d+(randn()*sd_d);
    if z>q_max
        res2=pc-((f*q_max*sp)/q_max);
    else
        res2=pc-((f*z*sp)/q_max);
    end
    tp=tp+res2;
end
rwp=tp/r;
fprintf('The reduced wholesaler price is %f\n',rwp)

q=[];
q(1)=m_d-(3*sd_d);
avg_profit=[];
avg_sum_wsp=[];
tscp=[];
j=1;
while q(j)<=(m_d+(3*sd_d))
    sum=0;
    sum_wsp=0;
    for u=1:r
        z=m_d+(randn()*sd_d);
        if z<q(j)
            profit=((1-f)*sp*z)+(sv*(q(j)-z))-(rwp*q(j));
            wsp=(f*sp*min(q_max,z))+(rwp*q(j))-(prc*q(j));
        else
            profit=((1-f)*sp*q(j))-(rwp * q(j))-(sc*(z-q(j)));
            wsp=(f*sp*min(q_max,z))+(rwp*q(j))-(prc*q(j));
        end
        sum_wsp=sum_wsp+wsp;
        sum=sum+profit;
    end
    avg_profit(j)=sum/r; 
    avg_sum_wsp(j)=sum_wsp/r;
    tscp(j)=avg_profit(j)+avg_sum_wsp(j);
    j=j+1;
    q(j)=q(j-1)+iv;
end
[max_profit,q_no]=max(avg_profit);
q_max=q(q_no);
l_q=size(q,2);
q(l_q)=[];

figure(1)
plot(q,avg_profit,'--mo')    
xlabel('Quantity')
ylabel('Profit')
title('Plot of Profit vs Quantity for Supply Chain Coordination')
hold on
plot(q,avg_sum_wsp,'-.r*')
hold on
plot(q,tscp,':bs')
legend('Retailer Profit','Wholesaler Profit', 'Total Profit',4);
